SystemOrganization addCategory: #GhostProxies!

Object subclass: #ClassProxy
	instanceVariableNames: 'target handler superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 14:09'!
createProxyAndReplace: aClass
   | aProxy newProxyRef newClassRef|
       aProxy := self new.
       aProxy handler: SimpleForwarderHandler new. 
       aProxy methodDict: nil.
       aProxy superclass: ClassProxy.
       aProxy format: ClassProxy format. 
       aProxy become: aClass.
        "After the become is done, aProxy now points to aClass 
        and aClass points to aProxy. We create two new variables
         just to clarify the code"
       newProxyRef := aClass.
       newClassRef := aProxy.
       newProxyRef target: newClassRef.
       ClassProxyTrap adoptInstance: newProxyRef.
       ^ newProxyRef.
! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 16:31'!
cannotInterpret: aMessage
	Transcript show: 'cannotInterpret message: ', aMessage selector.
	(ClassProxyTrap = aMessage lookupClass )
		ifTrue: [^ handler handleInterception: aMessage for: target proxy: self]
		ifFalse: [ ^ handler handleInterceptionToInstance: aMessage for: target andReceiver: self
]       ! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
format
	^ format! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
format: anObject
	format := anObject! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
handler
	^ handler! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
handler: anObject
	handler := anObject! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
methodDict
	^ methodDict! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
methodDict: anObject
	methodDict := anObject! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
superclass
	^ superclass! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
superclass: anObject
	superclass := anObject! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
target
	^ target! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
target: anObject
	target := anObject! !

ClassProxy subclass: #ClassProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:30'!
initialize
	superclass := ClassProxy.
	format := ClassProxy format.
	methodDict := nil.! !

Object subclass: #ObjectProxy
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:03'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new.
       aProxy target: anObject.
       aProxy handler: SimpleForwarderHandler new. 
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:46'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target proxy: self! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
handler
	^ handler! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
handler: anObject
	handler := anObject! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
target
	^ target! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
target: anObject
	target := anObject! !

ObjectProxy subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:58'!
initialize
	superclass := ObjectProxy.
	format := ObjectProxy format.
	methodDict := nil.! !

Object subclass: #SimpleForwarderHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:23'!
flushCacheOf: aCompiledMethod
	^ aCompiledMethod selector flushCache	 
		! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:43'!
handleInterception: aMessage for: aTargetObject
	Transcript show: 'message ', aMessage selector, ' intercepted and will be forwarded'; cr.
	(self isMethodExecutionInterception: aMessage)  ifTrue: [
		^ self handleMethodExecution: aMessage method: aTargetObject
		].
	(self isMethodFlushCache: aMessage)  ifTrue: [
		^ self flushCacheOf: aTargetObject  
		].
	(self isMethodUninstall: aMessage)  ifTrue: [
		^ self uninstall: aTargetObject  
		].
	^ aMessage sendTo: aTargetObject ! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:47'!
handleInterception: aMessage for: aTargetObject proxy: proxy
	Transcript show: 'message ', aMessage selector, ' intercepted and will be forwarded'; cr.
	(self isMethodExecutionInterception: aMessage)  ifTrue: [
		^ self handleMethodExecution: aMessage method: aTargetObject
		].
	(self isMethodFlushCache: aMessage)  ifTrue: [
		^ self flushCacheOf: aTargetObject  
		].
	(self isMethodUninstall: aMessage)  ifTrue: [
		^ self uninstall: aMessage target: aTargetObject  proxy: proxy.
		].
	^ aMessage sendTo: aTargetObject ! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 15:59'!
handleInterceptionToInstance: aMessage for: aClass andReceiver: anInstance

	Transcript show: 'message ', aMessage selector, ' to instance intercepted and will be forwarded'; cr.
	^ (aClass lookupSelector: aMessage selector) 
		executeWithReceiver: anInstance arguments: aMessage arguments 
	! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:10'!
handleMethodExecution: aMessage method: aTargetObject 
	"aMessage selector is the run:with:in: 
	"
	Transcript show: 'message ', aMessage selector, ' execution intercepted and will be forwarded'; cr.
	^ aTargetObject valueWithReceiver: aMessage arguments third arguments: aMessage arguments second
	
! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:07'!
isMethodExecutionInterception: aMessage
	^ aMessage selector = #run:with:in:! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:22'!
isMethodFlushCache: aMessage
	^ aMessage selector = #flushCache! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:44'!
isMethodUninstall: aMessage
	^ aMessage selector = #uninstall! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:49'!
uninstall: aMessage target: aTargetObject  proxy: proxy

	Transcript show: 'message ', aMessage selector, ' received and the proxy will be uninstalled'; cr.
	^ aTargetObject become: proxy.
	! !

Object subclass: #User
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!User classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:12'!
named: aName
	^ self new username: aName! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:09'!
username ^ username! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:08'!
username: anObject
	username := anObject! !
ClassProxyTrap initialize!
ObjectProxyTrap initialize!
